<?php
    /**
     * Unit source entity file.
     *
     * Creates the entity and makes it available.
     *
     * @category Entity
     */

    /**
     * Require dependent entities if not present.
     */
    require_once(PATH::ENTITY . "Entity.php");


    /**
     * Monster source.
     *
     * Represents an object from the table 'k_source'.
     *
     * @category Entity
     */
    class K_Source extends Entity{

        /**
         * @var int Unit identifier.
         */
        public $id;

        /**
         * @var string Source name.
         */
        public $name;

        /**
         * @var string Source description.
         */
        public $description;

        /**
         * @var bool Indicates if the source is farmable.
         */
        public $farmable;

        /**
         * Constructor.
         *
         * Searches the database and retrieves the information about the
         * monster, populating it and it's items.
         *
         * @param resource $db Connection to the database.
         * @param int $id Monster identifier.
         */
        public function __construct($db, $id){
            parent::__construct($db);
            $s =
              "SELECT " .
              "  id, " .
              "  name, " .
              "  description, " .
              "  farmable " .
              "FROM k_source " .
              "WHERE id = $id; ";
            $q = $this->db->query($s);
            $r = $q->fetchArray(SQLITE3_ASSOC);
            if ($r){
                $this->id = $r["id"];
                $this->name = HTML::e($r["name"]);
                $this->description = HTML::e($r["description"]);
                $this->farmable_source = $r["farmable"];
            }
        }

        /**
         * Gets the path to the source image. The image must be in the
         * img/source/ directory, and it's name must be the source id,
         * padded with '0' to 4 digits, and the extension must be '.png'.
         *
         * @return string Image URL, or a fixed unknown image.
         */
        public function get_image(){
            if (file_exists(PATH::BASE . "img/source/" . str_pad($this->id, 4, '0', STR_PAD_LEFT) . ".png")){
                return URL::IMG["SOURCE"] . str_pad($this->id, 4, '0', STR_PAD_LEFT) . ".png";
            }
            else{
                return URL::IMG["UNKNOWN"];
            }
        }

    }
?>
